diff -Naur -X ./exclude vnc_unixsrc.orig/libvncauth/vncauth.c vnc_unixsrc/libvncauth/vncauth.c
--- vnc_unixsrc.orig/libvncauth/vncauth.c	2003-03-01 11:48:06.000000000 -0500
+++ vnc_unixsrc/libvncauth/vncauth.c	2010-02-25 21:47:25.000000000 -0500
@@ -27,9 +27,11 @@
 #include <sys/types.h>
 #include <sys/stat.h>
 #include <unistd.h>
+#include <time.h>
 #include <vncauth.h>
 #include <d3des.h>
 
+#include <fcntl.h>
 
 /*
  * Make sure we call srandom() only once.
@@ -45,6 +47,8 @@
 
 static unsigned char s_fixedkey[8] = {23,82,107,6,35,78,88,7};
 
+int vncEncryptAndStorePasswd2(char *passwd, char *passwdViewOnly, char *fname);
+int vncDecryptPasswdFromFile2(char *fname, char *passwdFullControl, char *passwdViewOnly);
 
 /*
  * Encrypt a password and store it in a file.  Returns 0 if successful,
@@ -73,7 +77,7 @@
 vncEncryptAndStorePasswd2(char *passwd, char *passwdViewOnly, char *fname)
 {
     FILE *fp;
-    int i, bytesToWrite, bytesWrote;
+    int bytesToWrite, bytesWrote;
     unsigned char encryptedPasswd[16] = {
 	0,0,0,0,0,0,0,0,
 	0,0,0,0,0,0,0,0
@@ -195,6 +199,44 @@
     return (i < 16) ? 1 : 2;
 }
 
+unsigned int urandom(void) {
+	unsigned int val = 0;
+	struct stat sb;
+	int fd = -1;
+	if (fd < 0 && stat("/dev/urandom", &sb) == 0) {
+		fd = open("/dev/urandom", O_RDONLY);
+	}
+	if (fd < 0 && stat("/dev/random", &sb) == 0) {
+		fd = open("/dev/random", O_RDONLY);
+	}
+	if (fd < 0 && stat("/proc/loadavg", &sb) == 0) {
+		fd = open("/proc/loadavg", O_RDONLY);
+	}
+	if (fd < 0 && stat("/bin/bash", &sb) == 0) {
+		fd = open("/bin/bash", O_RDONLY);
+		lseek(fd, (off_t) (unsigned int) getpid(), SEEK_SET);
+	}
+	if (fd >= 0) {
+		int i;
+		for (i=0; i < 3; i++) {
+			char buf[2];
+			if (read(fd, buf, 1) > 0) {
+				unsigned char uc = (unsigned char) buf[0];  
+				if (i==0) {
+					val += uc; 
+				} else if (i==1) {
+					val += uc * 256; 
+				} else if (i==2) {
+					val += uc * 256 * 256; 
+				}
+			}
+		}
+		close(fd);
+	} else {
+		val = (unsigned int) getpid();
+	}
+	return val;
+}
 
 /*
  * Generate CHALLENGESIZE random bytes for use in challenge-response
@@ -207,11 +249,13 @@
     int i;
     unsigned int seed;
 
-    if (!s_srandom_called) {
-      seed = (unsigned int)time(0) ^ (unsigned int)getpid();
-      srandom(seed);
-      s_srandom_called = 1;
-    }
+	if (!s_srandom_called) {
+		seed = (unsigned int)time(0) ^ (unsigned int)getpid();
+		seed += urandom();
+
+		srandom(seed);
+		s_srandom_called = 1;
+	}
 
     for (i = 0; i < CHALLENGESIZE; i++) {
 	bytes[i] = (unsigned char)(random() & 255);    
@@ -245,3 +289,48 @@
 	des(bytes+i, bytes+i);
     }
 }
+
+void UvncEncryptPasswd_MSLOGON(unsigned char *encryptedPasswd, char *passwd) {
+	unsigned int i;
+	for (i=0; i < 32; i++) {
+		if (i < strlen(passwd)) {
+			encryptedPasswd[i] = passwd[i];
+		} else {
+			encryptedPasswd[i] = '\0';
+		}
+	}
+	deskey(s_fixedkey, EN0);
+	des(encryptedPasswd, encryptedPasswd);
+}
+
+void UvncEncryptBytes2(unsigned char *where, int length, unsigned char *key) {
+	int i, j;
+	deskey(key, EN0);
+	for (i=0; i < 8; i++) {
+		where[i] ^= key[i];
+	}
+	des(where, where);
+	for (i=8; i < length; i += 8) {
+		for (j=0; j < 8; j++) {
+			where[i+j] ^= where[i+j-8];
+		}
+		des(where+i, where+i);
+	}
+}
+
+void UvncDecryptBytes2(unsigned char *where, int length, unsigned char *key) {
+	int i, j;
+	deskey(key, DE1);
+	for (i = length - 8; i > 0; i -= 8) {
+		des(where + i, where + i);
+		for (j=0; j < 8; j++) {
+			where[i+j] ^= where[i+j-8];
+		}
+	}
+	/* i=0 */
+	des(where, where);
+	for (i=0; i < 8; i++) {
+		where[i] ^= key[i];
+	}
+}
+
